IMPLEMENTATION MODULE ClockTst;

IMPORT Lib3, Config, Clock;
IMPORT Ticks;
IMPORT IO;


PROCEDURE Pack();
VAR
  y, m, d: CARDINAL;
  x, xa: CARDINAL;

  PROCEDURE Show( s-: ARRAY OF CHAR );
  BEGIN
    IO.WrCard( y, 4 );
    IO.WrCard( m, 3 );
    IO.WrCard( d, 3 );
    IO.WrCard( x, 7 );
    IO.WrCard( xa, 7 );
    IO.WrStr( s );
    IO.WrLn();
  END Show;

BEGIN
  IO.WrStr( 'ClockTst.Pack' );
  IO.WrLn();
  x := 0; xa := 0;
  FOR y := 1000 TO 3000 DO
    FOR m := 0 TO 30 DO
      FOR d := 0 TO 100 DO
        x := Clock.PackDate( y, m, d );
        IF Clock.IsValidDate( y, m, d ) THEN
          IF x # xa THEN Show( ' inc' ) END;
          INC( xa );
        ELSE
          IF x # 0 THEN Show( ' inv' ) END;
        END;
        IF ( y = Clock.minYear )     & ( m = Clock.minMonth )     & ( d = Clock.minDay )     & ( x # MIN( Clock.TDate ) ) THEN Show( ' min' ) END;
        IF ( y = Clock.maxDateYear ) & ( m = Clock.maxDateMonth ) & ( d = Clock.maxDateDay ) & ( x # MAX( Clock.TDate ) ) THEN Show( ' max' ) END;
      END;
    END;
  END;
  IF xa # MAX( Clock.TDate ) + 1 THEN Show( ' max2' ) END;
  IO.WrStr( 'ClockTst.Pack done.' );
  IO.WrLn();
END Pack;

PROCEDURE Repack();
VAR
  a, b: Clock.TDate;
  y, m, d: CARDINAL;
BEGIN
  IO.WrStr( 'ClockTst.Repack' );
  IO.WrLn();
  FOR a := MIN( Clock.TDate ) TO MAX( Clock.TDate ) DO
    Clock.UnpackDate( a, y, m, d );
    b := Clock.PackDate( y, m, d );
    IF a # b THEN
      IO.WrCard( y, 4 );
      IO.WrCard( m, 3 );
      IO.WrCard( d, 3 );
      IO.WrCard( a, 3 );
      IO.WrCard( b, 5 );
      IO.WrStr( ' repack' );
      IO.WrLn();
    END;
    IF ~ Clock.IsValidDate( y, m, d ) THEN
      IO.WrCard( y, 4 );
      IO.WrCard( m, 3 );
      IO.WrCard( d, 3 );
      IO.WrStr( ' invalid' );
      IO.WrLn();
    END;
  END;
  IO.WrStr( 'ClockTst.Repack done.' );
  IO.WrLn();
END Repack;

PROCEDURE WeekDay();
BEGIN
  IO.WrStr( 'ClockTst.WeekDay' );
  IO.WrLn();
  IO.WrCard( ORD( Clock.WeekDay( 0 ) ), 1 );
  IO.WrLn();
  IO.WrCard( ORD( Clock.WeekDay( MAX(Clock.TDate) ) ), 1 );
  IO.WrLn();
  IO.WrStr( 'ClockTst.WeekDay done.' );
  IO.WrLn();
END WeekDay;

BEGIN
  Pack();
  Repack();
  WeekDay();
END ClockTst.
